//LCDڑp̃Cu
//2005/12/16
//wrote: aO
/*
void LCD_init(unsigned int MHz)		LCD
void LCD_char(unsigned char dat)	ꕶ\
void LCD_put2all(int c)				2i\(8)
void LCD_hex(int c)					16i\(2)
void LCD_hex_all(int c)				16i\(4)
void LCD_putdec(int c)				10i\
void LCD_print(const char *str)		\
void LCD_line1()					1sڂɃJ[\ړ
void LCD_line2()					2sڂɃJ[\ړ
void LCD_put01(int c)				2i\(1)
void LCD_clear()					Xy[Xɂĕ\NA
*/

#include	"reg3664.h"

#define LCD_port	IO.PDR5.BYTE
#define LCD_RS		IO.PDR5.BIT.B4
#define LCD_E		IO.PDR5.BIT.B5
#define LCD_DDR		IO.PCR5


static unsigned int _time20u;

static void _wait20u(void)
{
	unsigned int dmy;
	for( dmy= _time20u; dmy> 0; dmy--);
}

static void _wait(unsigned int tm)
{
	unsigned int i;
	for(i=0; i< (tm/2); i++)
		_wait20u();
}

void LCD_out4(unsigned char data)
{
	unsigned char tmp1, tmp2;

	LCD_E= 1;
	tmp1= LCD_port &0xf0;
	tmp2= (data >>4) &0x0f;
	LCD_port= tmp1 | tmp2;
	_wait20u();
	LCD_E= 0;
	_wait20u();

	LCD_E= 1;
	tmp1= LCD_port &0xf0;
	tmp2= data &0x0f;
	LCD_port= tmp1 | tmp2;
	_wait20u();
	LCD_E= 0;
	_wait20u();
}

static void _LCD_out8(unsigned char data)
{
	LCD_RS= 0;
	LCD_E= 1;
	LCD_port= data;
	_wait20u();
	LCD_E= 0;
	_wait20u();
}

//t&\
void LCD_init(unsigned int MHz)
{
	LCD_DDR = 0xff;
	if(MHz== 25)
		_time20u= 55;
	else
		_time20u= 36;

	_wait(1500);
	_LCD_out8(0x23);
	_wait(410);
	_LCD_out8(0x23);
	_wait(10);
	_LCD_out8(0x23);
	_wait(4);
	_LCD_out8(0x22);
	_wait(4);
	LCD_RS= 0;
	LCD_out4(0x28);
	_wait(4);
	LCD_RS= 0;
	LCD_out4(0x0e);
	_wait(4);
	LCD_RS= 0;
	LCD_out4(0x06);
	_wait(4);
	LCD_RS= 0;
	LCD_out4(0x01);
	_wait(164);
}

void LCD_locate(int line, int col)
{
	unsigned char dat;

	if(line== 1)
		dat= (unsigned char)col+ 0x80;
	if(line>= 2)
		dat= (unsigned char)col+ 0xc0;
	LCD_RS= 0;
	LCD_out4(dat);
}

//1\
void LCD_char(unsigned char dat)
{
	LCD_RS= 1;
	LCD_out4(dat);
	LCD_RS= 0;
}

//2i\
void LCD_put2all(int c)
{
	static char bits[]= "01";
	
	LCD_char(bits[(c>>7)& 1]);
	LCD_char(bits[(c>>6)& 1]);
	LCD_char(bits[(c>>5)& 1]);
	LCD_char(bits[(c>>4)& 1]);
	LCD_char(bits[(c>>3)& 1]);
	LCD_char(bits[(c>>2)& 1]);
	LCD_char(bits[(c>>1)& 1]);
	LCD_char(bits[c& 1]);
}

//2i\iR}wj
void LCD_put2(int c, int num)
{
	static char bits[]= "01";
	LCD_char(bits[(c>> (num-1))& 1]);
}

//16i\(2)
void LCD_puthex2(int c)
{
	static char hex[]= "0123456789abcdef";
	
	LCD_char(hex[(c>>4)& 15]);
	LCD_char(hex[c& 15]);
}

//16i\(4)
void LCD_puthex4(int c)
{
	static char hex[]= "0123456789abcdef";
	
	LCD_char(hex[(c>>12)& 15]);
	LCD_char(hex[(c>>8 )& 15]);
	LCD_char(hex[(c>>4 )& 15]);
	LCD_char(hex[c& 15]);
}

//10i\
void LCD_putdec(int c)
{
	int n;
	char tmp[10];

	for(n = 0; c&& n < 9; n++)
	{
		tmp[n]= '0'+ c% 10;
		c /= 10;
	}
	if(!n)
		tmp[n++]= 0;

	while(n> 0)
	{
		LCD_char(tmp[--n]);
	}
}

//\
void LCD_print(const char *str)
{
	while (*str)
		LCD_char(*str++);
}

//1sڂɃJ[\ړ
void LCD_line1()
{
	LCD_out4(0x80);
}

//2sڂɃJ[\ړ
void LCD_line2()
{
	LCD_out4(0xc0);
}

//2i\
void LCD_put01(int c)
{
	static char bits[]= "01";
	
	LCD_char(bits[c& 1]);
}

//Xy[Xɂĕ\NA
void LCD_clear()
{
	LCD_line1();
	LCD_print("                ");
	LCD_line2();
	LCD_print("                ");
}
