#define TMRW (*(volatile unsigned char *)0xff80)
#define TCRW (*(volatile unsigned char *)0xff81)
#define TIERW (*(volatile unsigned char *)0xff82)
#define TSRW (*(volatile unsigned char *)0xff83)
#define TIOR0 (*(volatile unsigned char *)0xff84)
#define TIOR1 (*(volatile unsigned char *)0xff85)
#define TCNT (*(volatile unsigned char *)0xff86)
#define GRA (*(volatile unsigned char *)0xff88)
#define GRB (*(volatile unsigned char *)0xff8a)
#define GRC (*(volatile unsigned char *)0xff8c)
#define GRD (*(volatile unsigned char *)0xff8e)
#define FLMCR1 (*(volatile unsigned char *)0xff90)
#define FLMCR2 (*(volatile unsigned char *)0xff91)
#define FLPWCR (*(volatile unsigned char *)0xff92)
#define EBR1 (*(volatile unsigned char *)0xff93)
#define FENR (*(volatile unsigned char *)0xff9b)
#define TCRV0 (*(volatile unsigned char *)0xffa0)
#define TCSRV (*(volatile unsigned char *)0xffa1)
#define TCORA (*(volatile unsigned char *)0xffa2)
#define TCORB (*(volatile unsigned char *)0xffa3)
#define TCNTV (*(volatile unsigned char *)0xffa4)
#define TCRV1 (*(volatile unsigned char *)0xffa5)
#define TMA (*(volatile unsigned char *)0xffa6)
#define TCA (*(volatile unsigned char *)0xffa7)
#define SMR (*(volatile unsigned char *)0xffa8)
#define BRR (*(volatile unsigned char *)0xffa9)
#define SCR3 (*(volatile unsigned char *)0xffaa)
#define TDR (*(volatile unsigned char *)0xffab)
#define SSR (*(volatile unsigned char *)0xffac)
#define RDR (*(volatile unsigned char *)0xffad)
#define ADDRA (*(volatile unsigned char *)0xffb0)
#define ADDRB (*(volatile unsigned char *)0xffb2)
#define ADDRC (*(volatile unsigned char *)0xffb4)
#define ADDRD (*(volatile unsigned char *)0xffb6)
#define ADCSR (*(volatile unsigned char *)0xffb8)
#define ADCR (*(volatile unsigned char *)0xffb9)
#define TCSRWD (*(volatile unsigned char *)0xffc0)
#define TCWD (*(volatile unsigned char *)0xffc1)
#define TMWD (*(volatile unsigned char *)0xffc2)
#define ICCR (*(volatile unsigned char *)0xffc4)
#define ICSR (*(volatile unsigned char *)0xffc5)
#define ICDR (*(volatile unsigned char *)0xffc6)
#define SARX (*(volatile unsigned char *)0xffc6)
#define ICMR (*(volatile unsigned char *)0xffc7)
#define SAR (*(volatile unsigned char *)0xffc7)
#define ABRKCR (*(volatile unsigned char *)0xffc8)
#define ABRKSR (*(volatile unsigned char *)0xffc9)
#define BARH (*(volatile unsigned char *)0xffca)
#define BARL (*(volatile unsigned char *)0xffcb)
#define BDRH (*(volatile unsigned char *)0xffcc)
#define BDRL (*(volatile unsigned char *)0xffcd)
//#define PUCR1 (*(volatile unsigned char *)0xffd0)
//#define PUCR5 (*(volatile unsigned char *)0xffd1)
//#define PDR1 (*(volatile unsigned char *)0xffd4)
//#define PDR2 (*(volatile unsigned char *)0xffd5)
//#define PDR5 (*(volatile unsigned char *)0xffd8)
//#define PDR7 (*(volatile unsigned char *)0xffda)
//#define PDR8 (*(volatile unsigned char *)0xffdb)
//#define PDRB (*(volatile unsigned char *)0xffdd)
//#define PMR1 (*(volatile unsigned char *)0xffe0)
//#define PMR5 (*(volatile unsigned char *)0xffe1)
//#define PCR1 (*(volatile unsigned char *)0xffe4)
//#define PCR2 (*(volatile unsigned char *)0xffe5)
//#define PCR5 (*(volatile unsigned char *)0xffe8)
//#define PCR7 (*(volatile unsigned char *)0xffea)
//#define PCR8 (*(volatile unsigned char *)0xffeb)
#define SYSCR1 (*(volatile unsigned char *)0xfff0)
#define SYSCR2 (*(volatile unsigned char *)0xfff1)
#define IEGR1 (*(volatile unsigned char *)0xfff2)
#define IEGR2 (*(volatile unsigned char *)0xfff3)
#define IENR1 (*(volatile unsigned char *)0xfff4)
#define IRR1 (*(volatile unsigned char *)0xfff6)
#define IWPR (*(volatile unsigned char *)0xfff8)
#define MSTCR1 (*(volatile unsigned char *)0xfff9)
#define TSCR (*(volatile unsigned char *)0xfffc)
#define IO (*(volatile struct st_io *)0xffd0)   /* IO    Address*/

struct st_io {                                          /* struct IO    */
             union {                                    /* PUCR1        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char   :1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PUCR1;                  /*              */
             union {                                    /* PUCR5        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:2;           /*    Bit 7,6   */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PUCR5;                  /*              */
             char               wk1[2];                 /*              */
             union {                                    /* PDR1         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char   :1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PDR1;                   /*              */
             union {                                    /* PDR2         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:5;           /*    Bit 7-3   */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PDR2;                   /*              */
             char               wk2[2];                 /*              */
             union {                                    /* PDR5         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PDR5;                   /*              */
             char               wk3;                    /*              */
             union {                                    /* PDR7         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          }      BIT;                   /*              */
                   }            PDR7;                   /*              */
             union {                                    /* PDR8         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PDR8;                   /*              */
             char               wk4;                    /*              */
             union {                                    /* PDRB         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PDRB;                   /*              */
             char               wk5[2];                 /*              */
             union {                                    /* PMR1         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char IRQ3:1;         /*    IRQ3      */
                          unsigned char IRQ2:1;         /*    IRQ2      */
                          unsigned char IRQ1:1;         /*    IRQ1      */
                          unsigned char IRQ0:1;         /*    IRQ0      */
                          unsigned char     :2;         /*              */
                          unsigned char TXD :1;         /*    TXD       */
                          unsigned char TMOW:1;         /*    TMOW      */
                          }      BIT;                   /*              */
                   }            PMR1;                   /*              */
             union {                                    /* PMR5         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char wk  :2;         /*              */
                          unsigned char WKP5:1;         /*    WKP5      */
                          unsigned char WKP4:1;         /*    WKP4      */
                          unsigned char WKP3:1;         /*    WKP3      */
                          unsigned char WKP2:1;         /*    WKP2      */
                          unsigned char WKP1:1;         /*    WKP1      */
                          unsigned char WKP0:1;         /*    WKP0      */
                          }      BIT;                   /*              */
                   }            PMR5;                   /*              */
             char               wk6[2];                 /*              */
             unsigned char      PCR1;                   /* PCR1         */
             unsigned char      PCR2;                   /* PCR2         */
             char               wk7[2];                 /*              */
             unsigned char      PCR5;                   /* PCR5         */
             char               wk8;                    /*              */
             unsigned char      PCR7;                   /* PCR7         */
             unsigned char      PCR8;                   /* PCR8         */
};                                                      /*              */


